//+------------------------------------------------------------------+
//|                                                          6pm.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com
//    v1.04.02 22/12/2015 sort issues at 495 - cumulate values for each TP/SL distintctly, so that the best one can be found (5 entries x 3 options - 15 combinations) number of available combination is variable.
//    v1.05.01 29/12/2015 flattened result arrays into one dim; selection of TP/SL on MathCeil(y/3);
//                        function isnewtick under progress  
//line 547- win/loss calculation incorrect
//      v1.06 03/01/2015 ArrayFunnel to diverge entrypoints into separate array for each strategy 
//      v1.07 16/03/2016 Maximum result for all strategies- if two max values equal, choose the one with the lower SL?
//+------------------------------------------------------------------+


//iks/iks2 - time vertical line incorrect





#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict


extern double lot=0.01;
extern int takeprofit=50;
extern int stoploss=50;
extern int TPlimit = 200;
extern int SLlimit = 100;
extern int scope=180;
extern int slippage=5;
extern int magic=248511;
extern int maxpendingorders= 8;
extern int maxactiveorders = 4;
extern double probability_limit = 0.5;
extern int TPSLvalue_limit = 350;
extern string candle= "Candle number at which you want to place orders 0,1,2,3)";
extern int opentime = 18;
extern int leftprominence=3;
extern int rightprominence=11;
extern int mindiff=50;


bool TradeLock = 1;
bool buyhighlock = 1;
bool buylowlock=1;
bool sellhighlock= 1;
bool selllowlock = 1;
datetime crnthigh;
datetime crntlow;
datetime tstmphigh;
datetime tstmplow;


//Array definitions:

double a_entryprice[];
datetime a_entrytime[];
string a_strategyname[];
string a_ordertype[];

int a_expiration[];
int a_takeprofit[];
int a_stoploss[];

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
/*
   double ticksize = MarketInfo(Symbol(),MODE_TICKSIZE);
   if (ticksize == 0.00001 || ticksize == 0.001)
   double pips = ticksize*10;
   else double pips = ticksize;
   */
   
   int t=(60 -(TimeSeconds(TimeCurrent())-TimeSeconds(Time[0])));
   int temp=TimeSeconds(TimeCurrent())-TimeSeconds(Time[0]);
   Comment(t);
   
   OrderClip TradeQueue;  
/*
   datetime testtime = "2015.12.08 14:50";
   int bartime = iBarShift(NULL,0,testtime,true);
   int result = TPSL_optimiser(Close[bartime],220,"pendingsell",0,bartime,30);
   Alert(result);
   //string result = TPorSL (1.0897,600,900,"instantbuy",bartime,50);
   //Alert(result);
   */

   int TP;
   int SL;
   double entryprice;
   datetime entrytime;
   string strategyname;
   string ordertype;
   
   HRM(entryprice,entrytime,ordertype);
   LRM(entryprice,entrytime,ordertype);
   Jazon(TP, SL);
     
   Print("TP is: ",TP, " SL is: ", SL);
//---
   EventSetTimer(t);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//Comment(TimeSeconds(TimeCurrent()));
   
   PeakRider();
   
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---

  }
  
  
  
  
  
  
  
  
  
  
 
//-----------STRATEGY FUNCTIONS------------------------------
//+------------------------------------------------------------------+

string TRM(int shift=0,int mashift=10,string symbol=NULL,int timeframe=5,int MAperiod=100,int mamethod=1,int appliedprice=0,double minSMAdiff=10)
  {

/*double sma_low=iMA(NULL,1,10,0,MODE_SMA,PRICE_LOW,0);
   //double sma_low_shift=iMA(NULL,1,10,0,MODE_SMA,PRICE_LOW,shift);
   //double sma_high=iMA(NULL,1,10,0,MODE_SMA,PRICE_HIGH,0);
   //double sma_high_shift=iMA(NULL,1,10,0,MODE_SMA,PRICE_HIGH,shift);
      if (sma_low-sma_low_shift > sma_high-sma_low && sma_low-sma_low_shift>0)
   {
   trend = "up";
   }
   else if (sma_low-sma_low_shift < sma_low-sma_high && sma_low-sma_low_shift<0)
   {
   trend="down";
   }
   else
   {trend="side";}
   */
   
   minSMAdiff=minSMAdiff*Point;

   double SMA=iMA(symbol,5,100,0,mamethod,appliedprice,shift);
   double prvsSMA=iMA(symbol,timeframe,MAperiod,mashift,mamethod,appliedprice,shift);
   


   if(SMA-prvsSMA>=minSMAdiff)
     {
      return ("UP");
     }
   else if(SMA-prvsSMA<=-minSMAdiff)
     {
      return("DOWN");
     }
   else
     {
      return("SIDE");
     }
  }

  
//+------------------------------------------------------------------+

double HRM(double &base_high, datetime &entrytime, string &HRM_ordertype)
  {
   int temp_counter=0;
   int x=scope;
   int iks=x;
   base_high=High[x];

   for(x=scope; x>rightprominence-1; x--)
     {
      //Sleep (50);
      Print(x,"High search");
      Print(scope);
      Print(High[x]);

      if(High[x+1]<=High[x] && High[x]>=High[x-1]) //swing down- initial test
        {
         temp_counter=1;
         //right prominence test
         while(temp_counter<rightprominence && High[x]>=High[x-temp_counter])
           {
            temp_counter++;
            //left prominence test
            if(temp_counter==rightprominence)
              {
               temp_counter=1;

               while(temp_counter<leftprominence+1 && High[x]>=High[x+temp_counter])
                 {
                  temp_counter++;
                 }
               if(temp_counter==leftprominence+1)
                 {
                  temp_counter=1;
                  base_high=High[x];
                  crnthigh = Time[x];
                  datetime crnthigh_entry= Time[x-rightprominence];
                  iks=x;
                  string trend=(TRM(x));
                  if(trend=="UP")
                    {
                     HRM_ordertype="pendingbuy";
                     ArrayFunnel(base_high,crnthigh_entry,HRM_ordertype,"HRM");
                    }
                  else if(trend=="SIDE")
                    {
                     HRM_ordertype="pendingsell";
                     ArrayFunnel(base_high,crnthigh_entry,HRM_ordertype,"HRM");
                    }
                  else
                    {
                     HRM_ordertype="notrade";
                     ArrayFunnel(base_high,crnthigh_entry,"notrade","HRM");
                    }
                  break;
                 }
               else
                 {break;}
              }
           }
        }
      if(x==rightprominence) {break; }
     }

   if(tstmphigh!=crnthigh)
     {
      ObjectDelete(ChartID(),"High vertical");
      ObjectDelete(ChartID(),"High horizontal");

      ObjectCreate(ChartID(),"High vertical",OBJ_VLINE,0,Time[iks],base_high);
      ObjectCreate(ChartID(),"High horizontal",OBJ_HLINE,0,Time[iks],base_high);
      ObjectSetInteger(ChartID(),"High vertical",OBJPROP_COLOR,clrYellow);
      ObjectSetInteger(ChartID(),"High horizontal",OBJPROP_COLOR,clrYellow);
            
      entrytime=Time[iks];
      
      
      return (base_high);
      tstmplow=crntlow;
     }
    else
    {
      entrytime=NULL;
      return(NULL);
    }


  }
//+------------------------------------------------------------------+

double LRM(double &base_low, datetime &entrytime, string &LRM_ordertype)
  {
   int scout_counter= 0;
   int temp_counter =0;
   int x=scope;
   int iks=x;

   base_low=Low[x];

   for(x=scope; x>rightprominence-1; x--)
     {
      //Sleep (50);
      Print(x,"Low search");
      Print(scope);
      Print(Low[x]);

      if(Low[x+1]-Low[x]>0.00000 && Low[x]<=Low[x-1]) //swing up- initial test
        {
         temp_counter=1;
         //right prominence test
         while(temp_counter<rightprominence && Low[x]<=Low[x-temp_counter])
           {
            temp_counter++;

            //left prominence test
            if(temp_counter==rightprominence)
              {
               temp_counter=1;
               while(temp_counter<leftprominence+1 && Low[x]<=Low[x+temp_counter])
                 {
                  temp_counter++;
                 }
               if(temp_counter==leftprominence+1)
                 {
                  temp_counter=1;
                  base_low=Low[x];
                  crntlow = Time[x];
                  datetime crntlow_entry= Time[x-rightprominence];
                  iks=x;
                  string trend=TRM(x);
                  if(trend=="DOWN")
                    {
                     LRM_ordertype="pendingsell";
                     ArrayFunnel(base_low,crntlow_entry,LRM_ordertype,"LRM");
                    }
                  else if(trend=="SIDE")
                    {
                     LRM_ordertype="pendingbuy";
                     ArrayFunnel(base_low,crntlow_entry,LRM_ordertype,"LRM");
                    }
                  else
                    {
                     LRM_ordertype="notrade";
                     ArrayFunnel(base_low,crntlow_entry,LRM_ordertype,"LRM");
                    }
                  break;
                 }
               else
                 { break;}
              }
           }
        }
      temp_counter=1;

      if(x==rightprominence)
        {break;     }
     }

   if(tstmplow!=crntlow)
     {
      ObjectDelete(ChartID(),"Low vertical");
      ObjectDelete(ChartID(),"Low horizontal");

      ObjectCreate(ChartID(),"Low vertical",OBJ_VLINE,0,Time[iks],base_low);
      ObjectCreate(ChartID(),"Low horizontal",OBJ_HLINE,0,Time[iks],base_low);
      ObjectSetInteger(ChartID(),"Low vertical",OBJPROP_COLOR,clrGreen);
      ObjectSetInteger(ChartID(),"Low horizontal",OBJPROP_COLOR,clrGreen);
      entrytime=Time[iks];
      return (base_low);
      tstmplow=crntlow;
     }
    else
      {
       entrytime=NULL;
       return(NULL);
      }
  }
//------------------------------------------------------------------------
//--------------------- TRADE FUCNTIONS-----------------------------------

void buy(double price,bool base, double TP, double SL)
  {
   if(price==Ask)
     {
      OrderSend(Symbol(),OP_BUY,lot,Ask,slippage,Bid-SL*Point,Ask+TP*Point,"Buyng Low at " && Ask,magic,0,Blue);
     }
  }
//-----------------------------------------------------------
void sell(double price,bool base, double TP, double SL)

  {
   if(price==Bid)
     {
      OrderSend(Symbol(),OP_SELL,lot,Bid,slippage,Ask+SL*Point,Bid-TP*Point,"Selling High at " && Bid,magic,0,Red);
     }
  }
//-----------------------------

void pendingbuy(double price, double TP, double SL)
  {
   OrderSend(Symbol(),OP_BUYLIMIT,lot,price,slippage,price-SL*Point,price+TP*Point,"Buyng Low at " && price,magic,0,Green);
   Print(GetLastError());
  }
//---------------------------
void pendingsell(double price, double TP, double SL)

  {
   OrderSend(Symbol(),OP_SELLLIMIT,lot,price,slippage,price+SL*Point,price-TP*Point,"Selling High at " && price,magic,0,Red);
   Print(GetLastError());
  }

//-------------------------------------------------------------------------
////--------------------- TRADE COORDINATOR -------------------------------
void PeakRider()
  {
   //OrderClip OrderQueue;
   
   static int TP;
   static int SL;
   static int ctrJazon_counter;
   ctrJazon_counter++;
   if(ctrJazon_counter==10)
    {
     ctrJazon_counter=0;
     Jazon(TP, SL);
    }
   string trend=TRM();

   //Comment("Base low is ",DoubleToStr(base_low,5)," Base high is ",DoubleToStr(base_high,5)," Trend is ",trend);

//Alert(crnthigh, crntlow);
   int TotalOrders=OrdersTotal();
   int ActiveOrders=Fopnactive(magic,TotalOrders);
   int PendingOrders=OrdersTotal()-Fopnactive(magic,TotalOrders);
   int maxtotalorders=maxactiveorders+maxpendingorders;
   
   double base_low;
   double base_high;
   datetime LRM_entry_time;
   datetime HRM_entry_time;
   string LRM_ordertype;
   string HRM_ordertype;
   HRM(base_high,HRM_entry_time,HRM_ordertype);
   //OrderQueue.Set_neworder(base_high,HRM_entry_time,HRM_ordertype,"HRM",TP,SL);
   LRM(base_low,LRM_entry_time,LRM_ordertype);
   //OrderQueue.Set_neworder(base_high,HRM_entry_time,HRM_ordertype,"HRM",TP,SL);
   if(TotalOrders<maxtotalorders)
     {
      if(Ask>base_high+(mindiff*Point) && PendingOrders<=maxpendingorders) //if Ask is at least mindiff points higher than base_high
       {
         pendingbuy(base_high,TP,SL);
         Alert("Pending buy high at ",base_high,TotalOrders,ActiveOrders,PendingOrders);
       }
       
       
      
      else if(trend=="down")
        {
         if(Bid<=(base_low-mindiff)*Point && PendingOrders<=maxpendingorders) // if Bid is at least mindiff points lower than base_low
           {
            pendingsell(base_low,TP,SL);
            Alert("Pending sell low at ",base_low,TotalOrders,ActiveOrders,PendingOrders);
           }
        }
      else if(trend=="side")
        {
         if(Bid<base_high-mindiff*Point && PendingOrders<=maxpendingorders) //if Bid is at least mindiff points lower than base high
           {
            pendingsell(base_high,TP,SL);
            Alert("Pending sell high at ",base_high,TotalOrders,ActiveOrders,PendingOrders);
           }

         else if(Ask>base_low+mindiff*Point && PendingOrders<=maxpendingorders) //if Ask is at least mindiff points higher than base low
           {
            Print("pendingbuy should be here at ",base_low);
            pendingbuy(base_low,TP,SL);
            Alert("Pending buy low at ",base_low,TotalOrders,ActiveOrders,PendingOrders);
           }
        }
     }
  }

//----------------------------------------------------------------------

  
  
//----------------------------------------------------------------------  
//----------- DISCOVERY FUNCTIONS --------------------------------------  

bool Jazon(int& TP, int& SL)
  {
   int sizelimit=ArraySize(a_entryprice);
   int i=0;
   int x=0;
   double maxTP[][4];
   double minSL[][4];
   double defsetting [][4];

   int timelimit;
   int filehandle = FileOpen("SwingRaider.csv", FILE_READ|FILE_WRITE|FILE_CSV,';');
   for(i=0;i<sizelimit;i++)
     {
      FileSeek(filehandle,0,SEEK_END);
      FileWrite(filehandle,a_entryprice[i],a_entrytime[i],a_ordertype[i],a_strategyname[i]);
     }
   
       FileSeek(filehandle,0,SEEK_END);
      FileWrite(filehandle,"maxTP[i][0]","maxTP[i][1]","maxTP[i][2]","maxTP[i][3]","minSL[i][0]","minSL[i][1]","minSL[i][2]","minSL[i][3]","defsetting[i][1]","defsetting[i][2]","defsetting[i][3]");

   // 1. feed a_outputarrays to TSPL_optimiser (min SL with ext takeprofit), (max TP with ext stpoloss)

   for(i=0;i<sizelimit;i++)
     {
      int bartime = iBarShift(NULL,0,a_entrytime[i],true);
      ArrayResize(minSL,i+1,20);
      ArrayResize(maxTP,i+1,20);
      ArrayResize(defsetting,i+1,20);
      maxTP[i][0] = TPSL_optimiser(a_entryprice[i],stoploss,a_ordertype[i],1,a_entrytime[i], timelimit);
      if(maxTP[i][0]<takeprofit)
        {
         minSL[i][0] = TPSL_optimiser(a_entryprice[i],maxTP[i][0],a_ordertype[i],0,a_entrytime[i], timelimit);
        }
      else
        {
         minSL[i][0]= TPSL_optimiser(a_entryprice[i],takeprofit,a_ordertype[i],0,a_entrytime[i], timelimit);
        }  
      FileSeek(filehandle,0,SEEK_END);
      FileWrite(filehandle,maxTP[i][0],"","","",minSL[i][0]);
      }
      
  // 2. feed (1) result to TPorSL -> check profit/loss 
         
      for(i=0;i<sizelimit;i++) //browsing through trade settings for maxTP and minSL and through entry points for defsetting
      {
         int tporsl_def = TPorSL(a_entryprice[i],takeprofit,stoploss,a_ordertype[i],a_entrytime[i], timelimit); 
         defsetting[0][2]=defsetting[0][2]+ tporsl_def;
         Wincounter(tporsl_def,defsetting,0,i);
         FileSeek(filehandle,0,SEEK_END);
         FileWrite(filehandle, "","","","","","","","",defsetting[0][1],defsetting[0][2],defsetting[0][3]);
         
         for(x=0;x<sizelimit;x++) // browsing through entry points for a given maxTP and minSL
           {
            int tporsl_max = TPorSL(a_entryprice[x],maxTP[i][0],stoploss,a_ordertype[x],a_entrytime[x], timelimit);
            int tporsl_min = TPorSL(a_entryprice[x],takeprofit,minSL[i][0],a_ordertype[x],a_entrytime[x], timelimit);
            maxTP[i][2]= maxTP[i][2]+tporsl_max;
            minSL[i][2]= minSL[i][2]+tporsl_min;
            
     // 2b calculate win/loss ratio         
            Wincounter(tporsl_max,maxTP,i,x);
            Wincounter(tporsl_min,minSL,i,x);
     //3. logging results in file     
            FileSeek(filehandle,0,SEEK_END);
            FileWrite(filehandle,maxTP[i][0], maxTP[i][1],maxTP[i][2],maxTP[i][3],minSL[i][0], minSL[i][1],minSL[i][2],minSL[i][3]);
           }
      } 
    // count win/loss ratio
    
    

   // 4. compare results of 2 for all strategies and choose the optimal solution (sort arrays and choose highest within limit)
   // 4a. merge all strategy results within probability limit
      
   double Results[];
   double TradeSet[][2];
   ArrayResize(Results,3*sizelimit,1); //3- number of strategies
   ArrayResize(TradeSet,3*sizelimit,1);
   x=0;
   
   if(defsetting[0][3]>probability_limit)
     {
      Results[x]=defsetting[0][2];
      TradeSet[x][0]= takeprofit;
      TradeSet[x][1]= stoploss;
      x++;
      FileSeek(filehandle,0,SEEK_END);
      FileWrite(filehandle,Results[x],TradeSet[x][0],TradeSet[x][1]);
     }
   for(i=0;i<sizelimit;i++)
     {
         if(maxTP[i][3]>probability_limit && maxTP[i][0]<TPSLvalue_limit)
           {
            Results[x]=maxTP[i][2];
            TradeSet[x][0]=maxTP[i][0];
            TradeSet[x][1]=stoploss;
            FileSeek(filehandle,0,SEEK_END);
            FileWrite(filehandle,Results[x],TradeSet[x][0],TradeSet[x][1]);
            x++;
           }
         if(minSL[i][3]>probability_limit && minSL[i][0]<TPSLvalue_limit)
           {
            Results[x]=minSL[i][2];
            TradeSet[x][0]=takeprofit;
            TradeSet[x][1]=minSL[i][0];
            FileSeek(filehandle,0,SEEK_END);
            FileWrite(filehandle,Results[x],TradeSet[x][0],TradeSet[x][1]);
            x++;
           }
     }
      
   // 4b. choose the highest score
   
   int optindex = ArrayMaximum(Results,WHOLE_ARRAY,0);
   TP = TradeSet[optindex][0];
   SL = TradeSet[optindex][1];
   
   FileSeek(filehandle,0,SEEK_END);
   FileWrite(filehandle,Results[optindex],TradeSet[optindex][0],TradeSet[optindex][1]);
   
   
   FileWrite(filehandle,"end of run");
   Alert("Jazon at the edge of the world");
      return (1);
   }
   
//-------------------------------------------------------------------
   void Wincounter (int val1, double& array[][], int run_number,int run_iteration)
      {
         if(val1>0)
           {
            array[run_number][1]=array[run_number][1]+1;
           }
         else
           {
            array[run_number][1]=array[run_number][1];
           } 
         
         array[run_number][3]=array[run_number][1]/(run_iteration+1);
      }
//-------------------------------------------------------------------
   int Fopnactive(int number,int total)

     {
      int opbuy=0;
      int opsell=0;
      int opactive=0;
      int opbuylmt=0;
      int opselllmt=0;
      int opbuystp=0;
      int opsellstp=0;
      int oppending=0;

      for(int i=0; i<total; i++)
        {
         if(!OrderSelect(i,SELECT_BY_POS))
           {
            Alert("Order not selected, error: ",GetLastError());
           }
         if(OrderMagicNumber()==number)
           {
            switch(OrderType())
              {
               case 0:  opbuy=opbuy+1;
               case 1:  opsell=opsell+1;
              }
           }
        }

      opactive=opbuy+opsell;
      return(opactive);
     }
//---------------------------------------------------------------------------------------------

/*
int limitvalue    max TP or min SL;
bool TPSL:        max TP = 1 (looking for max take profit with a given stop loss), minSL = 0 (searching minimal stop loss with a given take profit);
string ordertype: pendingbuy, instantbuy, pendingsell, instantsell;
int entrytime:    time of entry expressed in number of candles from current one (0);
int timelimit:    time limit expressed in number of candles;

*/

//find the min SL given TP or max TP given SL
   double TPSL_optimiser(double price,int limitvalue,string ordertype,bool TPSL,datetime entrytime,int timelimit)
     {
      
      int bartime = iBarShift(NULL,0,entrytime,true);
      if(timelimit==0)
        {timelimit=bartime;}
      int expiration=bartime-timelimit;
      int x;
      double maxTP;
      double minSL;
            
      if(ordertype=="pendingbuy" || ordertype=="instantbuy")
        {
         if(TPSL==1) //maxTP - given SL value
           {
            double limitprice=price-limitvalue*Point;
            for(x=bartime;x>expiration;x--)
              {
               if(Low[x]<=limitprice)
                 {
                  expiration=x;
                  timelimit= bartime-x+1; //+1 to include the first bar (function takes 0 to 9 inclusive if count==10)
                  int TPbar = iHighest(NULL,0,2,timelimit,expiration);
                  maxTP = (High[TPbar]-price-1*Point)/Point;
                  return (maxTP);
                 }
              }
             if(x==expiration)
               {
                int TPbar = iHighest(NULL,0,2,bartime-expiration,expiration);
                maxTP = (High[TPbar]-price-1*Point)/Point;
                return (maxTP);
               }
           }
         else //if (TPSL == 0) //minSL - given TP value
           {
            double limitprice=price+limitvalue*Point;
            for(x=bartime;x>expiration;x--)
              {
               if(High[x]>=limitprice)
                 {
                  expiration=x;
                  timelimit= bartime-x+1; //+1 to include the first bar (function takes 0 to 9 inclusive if count==10)
                  int SLbar = iLowest(NULL,0,1,timelimit,expiration);
                  minSL = (price - Low[SLbar]+1*Point)/Point;
                  return (minSL);
                 }
              }
            if(x==expiration)
              {
                  int SLbar = iLowest(NULL,0,1,bartime-expiration,expiration); 
                  minSL = (price - Low[SLbar]+1*Point)/Point;
                  return (minSL);
              }  
            return(0);
           }
        }
      if(ordertype=="pendingsell" || ordertype=="instantsell")
        {
         if(TPSL==1) //maxTP given SL
           {
            double limitprice=price+limitvalue*Point;
            for(x=bartime;x>expiration;x--)
              {
               if(High[x]>=limitprice) //SL search
                 {
                  expiration=x;
                  timelimit= bartime-x+1;//+1 to include the first bar (function takes 0 to 9 inclusive if count==10)
                  int TPbar = iLowest(NULL,0,1,timelimit,expiration); 
                  maxTP = (price - Low[TPbar]-1*Point)/Point;
                  return (maxTP);
                 }
              }
            if(x==expiration)
              {
               int TPbar = iLowest(NULL,0,1,bartime-expiration,expiration);
               maxTP = (price - Low[TPbar]-1*Point)/Point;
               return (maxTP);
              }
            return(0);
           }

         else //if (TPSL == 0) //minSL - given TP value
           {
            double limitprice=price-limitvalue*Point;
            for(x=bartime;x>expiration;x--)
              {
               if(Low[x]<=limitprice) // searching for Low[x] lower than TP price
                 {
                  expiration=x;
                  timelimit= bartime-x+1; //+1 to include the first bar (function takes 0 to 9 inclusive if count==10)
                  int SLbar = iHighest(NULL,0,MODE_HIGH,timelimit,expiration); 
                  minSL = (High[SLbar]-price+1*Point)/Point;
                  return (minSL);
                 }  
              }
            if(x==expiration)
              {
               int SLbar = iHighest(NULL,0,2,bartime-expiration,expiration);
               minSL = (High[SLbar]-price+1*Point)/Point; //fix the price result (not points);
               return(minSL);
              }
            return(0);

           }
        }
      else return(0);
     }


//----------------------------------------------------------------------------
//which is hit first- TP or SL? at given price, entrytime and TP/SL levels

   double TPorSL(double price,double tprofit,double sloss,string ordertype,datetime entrytime,int timelimit)
     {
      double TP;
      double SL;
      int bartime = iBarShift(NULL,0,entrytime,true);
      if(timelimit==0) {timelimit=bartime;}
      int expiration=bartime-timelimit;
      int x;
          
      
      if(ordertype=="pendingbuy" || ordertype=="instantbuy")
        {
         TP = price + tprofit*Point;
         SL = price - sloss*Point;

         for(x=bartime; x>expiration; x--)
           {
            if(High[x]>=TP)
              {
               return(tprofit);
               string strTP=DoubleToStr(TP,5);
               Print("TP at " && strTP);
               break;
              }
            else if(Low[x]<=SL)
              {
               return(-sloss);
               string strSL=DoubleToStr(SL,5);
               Print(StringConcatenate("SL at ",strSL));
               break;
              }
           }
         if(x==expiration)
           {
            string str_expiration=IntegerToString(expiration,3); //check output
            Print("Expired at ", str_expiration);
            return(0);
           }
         else
           {
            Print("chuj");
           }
        }
      else if(ordertype=="pendingsell" || ordertype=="instantsell")
        {
         TP= price-tprofit*Point;
         SL= price+sloss*Point;

         for(x=bartime; x>expiration;x--)
           {
            if(Low[x]<=TP)
              {
               string strTP=DoubleToStr(TP,5);
               return(tprofit);
               Print("TP at " && strTP);
               break;
              }

            if(High[x]>=SL)
              {
               return(-sloss);
               string strSL=DoubleToStr(SL,5);
               Print(StringConcatenate("SL at ",strSL));
               break;
              }
           }

         if(x==expiration)
           {
            string str_expiration=IntegerToString(expiration,3); //check output
            Print(StringConcatenate("Expired at ",str_expiration));
            return(0);
           }
        }
      return(0);
     }

//----------------------------------------------------------------------------

   void ArrayFunnel(double entryprice,datetime entrytime,string ordertype,string strategyname,int o_expiration=0,int o_takeprof=0,int o_stopl=0)
     {
      static int x=0;

      if(o_takeprof==0)
        {
         o_takeprof=takeprofit;
        }

      if(o_stopl==0)
        {
         o_stopl=stoploss;
        }
      
      if(ordertype=="pendingbuy"||ordertype=="pendingsell")
        {
         o_expiration=EntryInstantiator(entryprice,entrytime,o_expiration);
        }
      
      if(o_expiration==-1 || ordertype=="notrade")
        {
         return;
        }
        
      ArrayResize(a_entryprice,x+1,10);
      ArrayResize(a_entrytime,x+1,10);
      ArrayResize(a_ordertype,x+1);
      ArrayResize(a_expiration,x+1);
      ArrayResize(a_takeprofit,x+1);
      ArrayResize(a_stoploss,x+1);
      ArrayResize(a_strategyname,x+1);


      if(ordertype=="instantbuy" || ordertype=="instantsell" || ordertype=="pendingbuy" || ordertype=="pendingsell")
        {
         a_entryprice[x]= entryprice;
         a_entrytime[x] = entrytime;

         a_ordertype[x]=ordertype;

         a_expiration[x] = o_expiration;
         a_takeprofit[x] = o_takeprof;
         a_stoploss[x]=o_stopl;
         a_strategyname[x]=strategyname;
        }
      else if(ordertype=="notrade")
        {
         return;
        }
      else //undefined or unrecognized order type
        {
         a_entryprice[x]= entryprice;
         a_entrytime[x] = entrytime;

         a_ordertype[x]="instantbuy";

         a_expiration[x] = o_expiration;
         a_takeprofit[x] = o_takeprof;
         a_stoploss[x]=o_stopl;
         a_strategyname[x]=strategyname;

         Print("Undefined or unrecognized order type, filling in with both instantbuy & instantsell");
         x++;
         ArrayResize(a_entryprice,x+1);
         ArrayResize(a_entrytime,x+1);
         ArrayResize(a_ordertype,x+1);
         ArrayResize(a_expiration,x+1);
         ArrayResize(a_takeprofit,x+1);
         ArrayResize(a_stoploss,x+1);
         ArrayResize(a_strategyname,x+1);
         a_entryprice[x]= entryprice;
         a_entrytime[x] = entrytime;

         a_ordertype[x]="instantsell";

         a_expiration[x] = o_expiration;
         a_takeprofit[x] = o_takeprof;
         a_stoploss[x]=o_stopl;
         a_strategyname[x]=strategyname;
        }
      x++;
     }
//-----------------------------------------------------------------------------




//-----------------------------------------------------------------------------
// Finds the entry point for an instant trade based on desired entry price and current time (when a pending trade is triggered);
// Updates the expiration value to match the new entry time and maintain the overall original value
  int EntryInstantiator (double entryprice, datetime& entrytime, int o_expiration=0)
  {
      int bartime = iBarShift(NULL,0,entrytime,true)-1; //added -1 to correct for the fact that entry will be one bar after the minimum limit
      int x = 0;
      
      for(x=bartime;x>o_expiration;x--)
      {
      if((entryprice<=Open[bartime] && Low[x]<=entryprice)||(entryprice>=Open[bartime] && High[x]>=entryprice))
        {
         entrytime = Time[x];
         if(o_expiration!=0)
           {
            o_expiration = o_expiration-(bartime-x);
            return (o_expiration);
           }
         break;
        }
      }
     
     if(x==o_expiration)
       {
        return(-1);
       }
     return(o_expiration);
  }
 
 
//------------------------------------
 bool IsNewBar()
 {
   static int bars;
   
   if(bars<Bars)
     {
      bars = Bars;
      TradeLock=0;
      return (1);
     }
   else
     {
      return(0);
     }
 }
 
//------------------------------------
//------STRUCTURES-----------

   struct entry
     {
      double            entry_price;
      datetime          entry_time;

      string            ordertype;    //if NULL - create both buy and sell

      int          expiration;
      int               TP;              //if NULL - takeprofit
      int               SL;              //if NULL - stoploss


     };



//--------------CLASSES--------------------


class OrderClip
  {
      private:
      
         double clip_price[];
         datetime clip_entrytime[];
         string clip_ordertype[];
         string clip_strategyname[];
         int clip_TP[];
         int clip_SL[];
         int clip_o_expiration[];
                  
      public:
      
         double GetClip_price(double &array[])
         {
            int total = ArraySize(clip_price);
            ArrayResize(array,total,0);
            
            for(int i=0;i<total;i++)
              {
               array[i]=clip_price[i];
              }
            return(NULL);
         }
      
        
        double Get_lastprice (double price)
        {
            price = clip_price[ArraySize(clip_price)-1];
            return(price);
        }
        
        
        
        void Get_cliporder (int ordernumber, double &entryprice, datetime &entrytime, string &ordertype, string &strategyname, int &TP, int &SL, int &o_expiration)
         {
         
            entryprice = clip_price[ordernumber];
            entrytime = clip_entrytime[ordernumber];
            ordertype = clip_ordertype[ordernumber];
            strategyname = clip_strategyname[ordernumber];
            TP = clip_TP [ordernumber];
            SL = clip_SL [ordernumber];
            o_expiration = clip_o_expiration[ordernumber];
         
         }
         
        
         void Set_newprice (double entryprice)  
            {
            int n=0;
            n = ArraySize(clip_price);
            if(entryprice)
              {
                  n++;
                  ArrayResize(clip_price,n,0);
                  clip_price[n-1]=entryprice;
              }
            }
            

        void Set_neworder (double entryprice, datetime entrytime, string ordertype, string strategyname, int TP, int SL, int o_expiration=0)  
         {
         int n=0;
         n = ArraySize(clip_price);
         n = ArraySize(clip_entrytime);
         n = ArraySize(clip_ordertype);
         n = ArraySize(clip_strategyname);
         n = ArraySize(clip_TP);
         n = ArraySize(clip_SL);
         if(entryprice)
           {
               n++;
               ArrayResize(clip_price,n,0);
               ArrayResize(clip_entrytime,n,0);
               ArrayResize(clip_ordertype,n,0);
               ArrayResize(clip_strategyname,n,0);
               ArrayResize(clip_TP,n,0);
               ArrayResize(clip_SL,n,0);
               clip_price[n-1]=entryprice;
               clip_entrytime[n-1]=entrytime;
               clip_ordertype[n-1]=ordertype;
               clip_strategyname[n-1]=strategyname;
               clip_TP[n-1]=TP;
               clip_SL[n-1]=SL;
           }
         }
      
      
  };

/*
class COpentrades
{
   private:
   
   int opbuy;
   int opsell ;
   int opactive;
   int opbuylmt ;
   int opselllmt ;
   int opbuystp ;
   int opsellstp ;
   int oppending ;
   
   int ordertype;
   
   public:
   
   int Fopnactive(magic, total)
   {
   for (int i=0; i<total; i++)
   {
      OrderSelect(i,SELECT_BY_POS);
      if (OrderMagicNumber()==magic)
      {
         switch()
         {
            case 0:  opbuy=opbuy+1;
            case 1:  opsell=opsell+1;   
            case 2:  opbuylmt=opbuylmt+1;  
            case 3:  opselllmt=opselllmt+1;
            case 4:  opbuystp=opbuystp+1;
            case 5:  opsellstp=opsellstp+1;
            default: NULL;
         }
      }
   }      
   
   opactive = opbuy+opsell;
   oppending = opbuylmt+opselllmt+opbuystp+opsellstp;
   
   return(opactive);
   }
   
   
   
   int Fopnpending (magic, total)
   {
      for (int i=0; i<total; i++)
   {
      OrderSelect(i,SELECT_BY_POS);
      if (OrderMagicNumber()==magic)
      {
         switch(OrderType())
         {
            case 0:  opbuy=opbuy+1;
            case 1:  opsell=opsell+1;   
            case 2:  opbuylmt=opbuylmt+1;  
            case 3:  opselllmt=opselllmt+1;
            case 4:  opbuystp=opbuystp+1;
            case 5:  opsellstp=opsellstp+1;
            default: NULL;
         }
      }
   }      
   
   opactive = opbuy+opsell;
   oppending = opbuylmt+opselllmt+opbuystp+opsellstp;
   
   return(int oppending);
   }
}
     
*/



/*
class CTrade
{
   public:
   double price;
   bool lock;
   int name;
   int slippage;
   
   bool pricechecker() 
   {
      if (Ask-price == slippage || price-Ask==slippage) 
      {
         return(true);
      }
      else return(false);
   }
             
};
*/
//+------------------------------------------------------------------+
